case Command of
  config ->
    #{alive := Alive} = Args,
    case whereis(balancer_iptv_client_s1) of
      undefined when Alive == true -> 
        {ok, Pid1} = hls_stress_test:start_link(balancer_iptv_client_s1, "http://balancer.local:7060/lb/s1"),
        {ok, Pid2} = hls_stress_test:start_link(balancer_iptv_client_s2, "http://balancer.local:7060/lb/s2"),
        {ok, Pid3} = hls_stress_test:start_link(balancer_iptv_client_s3, "http://balancer.local:7060/lb/s3"),
        unlink(Pid1),
        unlink(Pid2),
        unlink(Pid3),
        ok;
      Pid when is_pid(Pid) andalso Alive =/= true ->
        catch erlang:exit(whereis(balancer_iptv_client_s2),shutdown),
        catch erlang:exit(whereis(balancer_iptv_client_s3),shutdown),
        erlang:exit(Pid, shutdown);
      _ ->
        ok
    end,

    ClientCount = 
      try hls_stress_test:client_count(balancer_iptv_client_s1) catch _:_ -> 0 end +
      try hls_stress_test:client_count(balancer_iptv_client_s2) catch _:_ -> 0 end +
      try hls_stress_test:client_count(balancer_iptv_client_s3) catch _:_ -> 0 end,
    #{stress_client_count => ClientCount};


  add_clients ->
    #{count := Count} = Args,
    hls_stress_test:change_count(balancer_iptv_client_s1, Count),
    hls_stress_test:change_count(balancer_iptv_client_s2, Count),
    hls_stress_test:change_count(balancer_iptv_client_s3, Count),
    true
end.

