function normalizeUrl(url) {
  var a = document.createElement('a');
  a.href = url;
  a.hostname = window.location.hostname;
  return a.href;
}



function loadApp(data) {
  if(document.querySelector('#instance')) Vue.component('instance', {
    props: ['srv', 'qs'],
    template: document.querySelector('#instance').innerText,
    methods: {
      launch: function() {
        fetch("/demo/api/instances/"+this.srv.name, {method: "post", credentials: 'same-origin'}).then(r => r.json());
      },

      stop: function() {
        fetch("/demo/api/instances/"+this.srv.name, {method: "delete", credentials: 'same-origin'}).then(r => r.json());
      },

      openAdminUI: function() {
        var tmp_url = 'http://'+this.srv.name+':'+this.srv.config.http[0];
        window.open(normalizeUrl(tmp_url), "_blank")
      },

      play: function(stream) {
        var tmp_url = 'http://'+this.srv.name+':'+this.srv.config.http[0]+'/'+stream+'/embed.html?';
        if (this.qs) tmp_url = tmp_url + this.qs;
        this.$emit('play', tmp_url);
      },
      command: function(cmd, options) {
        options.name = this.srv.name;
        options.command = cmd;
        fetch("/demo/api/command", {method: "post", credentials: 'same-origin', 
          body: JSON.stringify(options)}).then(function(response) {
          return response.json()
        });
      },      
    },
  });  

  return new Vue({
    el: '#app',
    data: data,
    methods: {
      launchAll: function() {
        data.instances.forEach(function(i) {
          fetch("/demo/api/instances/"+i.name, {method: "post", credentials: 'same-origin'}).then(r => r.json());        
        });
      },
      stopAll: function() {
        data.instances.forEach(function(i) {
          fetch("/demo/api/instances/"+i.name, {method: "delete", credentials: 'same-origin'}).then(r => r.json());        
        });
      },

      playEmbedUrl: function(url, client_ip, user) {
        if (user) {
          this.play_url = url+"&token="+user+'-'+(new Date()).getTime()
        } else {
          this.play_url = url+"&token=u42-"+(new Date()).getTime()        
        }
        this.play_url_long = this.play_url ;
        self = this;
        console.log(this.play_url_long);

        var http = new XMLHttpRequest();
        http.open('HEAD', normalizeUrl(self.play_url_long));
        http.setRequestHeader("x-no-redirect", "yes");
        if (client_ip) {
          http.setRequestHeader("x-real-ip", client_ip);
          console.log('Set X-Real-Ip: header with '+ client_ip) 
        }
        http.onreadystatechange = function() {
          if (this.readyState === this.DONE) {
            console.log('Recieve readystate DONE ') 

            if(this.getResponseHeader("Location")) {
              console.log('Redirect to ' + this.getResponseHeader("Location")) 
              self.play_url = this.getResponseHeader("Location");
              self.play_url_long = this.getResponseHeader("Location");
            }

            if(this.status == 403) {
              document.getElementById("embedPlayer").src = "/403.html";
//              document.getElementById("embedMSEPlayer").src = "/403.html";
            } else { 
              console.log("Url long : " + self.play_url_long);
              document.getElementById("embedPlayer").src = normalizeUrl(self.play_url_long);
              self.play_mse_url = self.play_url+'&realtime=true'
//              document.getElementById("embedMSEPlayer").src = normalizeUrl(self.play_url_long+'&realtime=true');
            }
          } 
        };
        http.send();

      }

    }
  });
}
