function loadApp(data) {
  return new Vue({
    el: "#app",
    data: data,
    methods: {
      play: function (url) {
        let video1 = document.getElementById('play1');
        let pc = new RTCPeerConnection({ iceServers: [{ urls: 'stun:stun.l.google.com:19302' }] });
        pc.addTransceiver('video', { 'direction': 'sendrecv' }); // need SSRC in offer
        pc.addTransceiver('audio', { 'direction': 'sendrecv' });
        pc.addEventListener('iceconnectionstatechange', whipwhap.handleIceStateChange);
        pc.addEventListener('negotiationneeded', ev => whipwhap.handleNegotiationNeeded(ev, url));
        pc.ontrack = ev => video1.srcObject = ev.streams[0];
        this.player = pc;
      },

      play_stop: function () {
        // TODO stop whipwhap.handleNegotiationNeeded async
        let video1 = document.getElementById('play1');
        video1.srcObject && video1.srcObject.getTracks().forEach(track => track.stop());
        video1.srcObject = null;
        this.player && this.player.close();
        this.player = null;
      },

      publish: function (url) {
        let that = this;
        let video1 = document.getElementById('publish1');
        let pc = new RTCPeerConnection({ iceServers: [{ urls: 'stun:stun.l.google.com:19302' }] });
        pc.addEventListener('iceconnectionstatechange', whipwhap.handleIceStateChange);
        pc.addEventListener('negotiationneeded', ev => whipwhap.handleNegotiationNeeded(ev, url));
        navigator.mediaDevices.getUserMedia({ audio: true, video: true })
          .then(function (stream) {
            pc.addTransceiver(stream.getVideoTracks()[0], { 'direction': 'sendonly' });
            pc.addTransceiver(stream.getAudioTracks()[0], { 'direction': 'sendonly' });
            that.publisher = pc;
            video1.srcObject = stream;
            video1.play();
          })
          .catch(function (err) {
            this.log(err);
          });
      },

      publish_stop: function () {
        // TODO stop whipwhap.handleNegotiationNeeded async
        let video1 = document.getElementById('publish1');
        video1.srcObject && video1.srcObject.getTracks().forEach(track => track.stop());
        video1.srcObject = null;
        this.publisher && this.publisher.close();
        this.publisher = null;
      }
    }
  });
}
